'------------------------------------------------------------------------
'------------------------------------------------------------------------
'------------------------------------------------------------------------
'---                     Fetch_Image.vbs (v2.02)                      ---
'---                      - Fetch_Image - v2.02                       ---
'---                                                                  ---
'---                         -- Author: ViX --                        ---
'---                please keep the strips still coming               ---
'---                                                                  ---
'---                       ViX @ Samurize forum                       ---
'---           ViX @ news:finet.binaries.keskustelu.samurize          ---
'------------------------------------------------------------------------
'------------------------------------------------------------------------
'------------------------------------------------------------------------
'
'           Usage:
'           ------
'
'           1)  Extract
'               *Fetch Image.vbs             to Samurize\scripts -folder
'               *Fetch Image.ini             to Samurize\Configs -folder
'               *Fetch Image.xml & Error.png to Samurize -folder
'           2)  Add Activescript meter to your Samurize config
'                 -Draw type = Image
'           3)  Select Fetch Image.vbs
'           4)  Select function Fetch_Image
'                 -Set 'Image' as Source picture you want to show in
'                  Samurize
'                  for ex. <strip name="B.C"> so you put B.C and so on
'           5)  Set Run every X min (suggestion 1-120)
'                 -WebCam to daily updated comics
'
'------------------------------------------------------------------------
'
'            History:
'            --------
'
'            15.2.2004  - Fetch_Image - v1.0
'                           *Initial release
'
'            16.2.2004  - Fetch_Image - v1.01
'                           *Fixed bug
'                           *Fixed BIG bug in Looppi (iltalehti)
'                           *Added features
'                            +You can make meter-Linkage to open it in
'                             Internet Explorer
'
'            24.4.2004  - Fetch_Image - v2.0
'                           *Rewritten
'                            +Jaap's ideas was GREAT
'
'            1.5.2004   - Fetch_Image - v2.01
'                           *Moved features to .xml:
'                            +Delete old files
'                             True / False  --> Frees some space / Collect all
'                            +Link to file
'                             True / False  --> Open file in Internet
'                                               Explorer when clicked
'                                               requires:
'                                                Meter-linkage in config
'                            +expiry time in mins
'                             I think this is quite self-explained :)
'                             for ex.
'                              0    = Load image every time --> WebCam
'                              1440 = 24 hours              --> Comics etc.
'                            +Error.png
'                            +http://vix.no-ip.info/Fetch Image.xls
'                              I made a simple excel table of now available strips.
'                              Run macro to get prober .xml-file.
'                              (Tested with Office XP)
'                            +http://vix.no-ip.info/Fetch Image.xml
'                              if the links isn't working try again after a while.
'                              My computer might be down (patience).
'
'                              !!!Check links sometimes for new strips!!!
'
'            3.5.2004   - Fetch_Image - v2.02
'                           *Fixed bug in error handling
'
'------------------------------------------------------------------------
'------------------------------------------------------------------------
'------------------------------------------------------------------------


'------------------------------------------------------------------------
'----------------- Do not touch from this point forward -----------------
'------------------------------------------------------------------------

Function Fetch_Image(Image)

' Path to TEMP folder
    Dim fso
    Set fso = CreateObject("Scripting.FileSystemObject")

    Dim str_TempPath
    str_TempPath = fso.GetSpecialFolder(2) & "\WeatherMaps\"
    If Not fso.FolderExists(str_TempPath) Then
        fso.CreateFolder (str_TempPath)
    End If
    str_TempPath = str_TempPath & Image & "\"
    If Not fso.FolderExists(str_TempPath) Then
        fso.CreateFolder (str_TempPath)
    End If

' Get image URL and other properties
    Dim objXML, ComicXML, ma
    Dim HTML, URL
    Dim objRE
    Set objRE = New RegExp
    Dim Link_to_File, Delete_Old_Files, ExpiryTimeInMins

    Set objXML = CreateObject("Microsoft.XMLDOM")
    objXML.async = False
    objXML.LoadXML (ReadXML())
    If (objXML.parseError.errorCode <> 0) Then
        Fetch_Image = SamurizePath & "Error.png"
        Set objXML = Nothing
        Exit Function
    End If
    Set ComicXML = objXML.selectSingleNode("/Fetch_Image/strip[@name='" & Image & "']")
    Link_to_File = CBool(ComicXML.selectSingleNode("./meter_linkage").Text = "True")
    Delete_Old_Files = CBool(ComicXML.selectSingleNode("./delete_old").Text = "True")
    ExpiryTimeInMins = CLng(ComicXML.selectSingleNode("./expiry_time").Text)
    If (ComicXML.selectSingleNode("./imageurl") Is Nothing) Then
        objRE.Pattern = ComicXML.selectSingleNode("./searchpattern").Text
        objRE.Global = False
        HTML = ReturnHTML(ComicXML.selectSingleNode("./homepage").Text)
        If HTML <> False Then
            Set ma = objRE.Execute(HTML)
            URL = ComicXML.selectSingleNode("./imagebaseurl").Text & ma(0).SubMatches(0)
        Else
            URL = False
        End If
    Else
        URL = ComicXML.selectSingleNode("./imageurl").Text
        
        Dim YearLong, YearShort, MonthLong, MonthShort, DayLong, DayShort
        YearLong = Year(Date)
        YearShort = Right(YearLong, 2)
        
        MonthShort = Month(Date)
        If (MonthShort < 10) Then
        MonthLong = "0" & MonthShort
        Else
        MonthLong = MonthShort
        End If

        DayShort = Day(Date)
        If (DayShort < 10) Then
        DayLong = "0" & DayShort
        Else
        DayLong = DayShort
        End If

        
        URL = Replace(URL, "%Y", YearLong)
        URL = Replace(URL, "%y", YearShort)
        URL = Replace(URL, "%M", MonthLong)
        URL = Replace(URL, "%m", MonthShort)
        URL = Replace(URL, "%D", DayLong)
        URL = Replace(URL, "%d", DayShort)
    End If

    Set objRE = Nothing
    Set ComicXML = Nothing
    Set objXML = Nothing

    If (URL <> False And URL <> "XML parsing error") Then

    ' Tempimage name
        Dim str_TempImg, FileExt
        Dim Lopetus
        Lopetus = InStrRev(URL, "/", -1)
        str_TempImg = Right(URL, Len(URL) - Lopetus)
        str_TempImg = str_TempPath & str_TempImg

    ' Delete old files --> Frees some space
        If Delete_Old_Files Then
            Dim f1, fc, f
            Set f = fso.GetFolder(str_TempPath)
            Set fc = f.Files
            For Each f1 In fc
                If f1 <> str_TempImg Then
                    fso.DeleteFile (f1)
                End If
            Next
            Set f1 = Nothing
            Set fc = Nothing
        End If

        Dim Fetch
        Fetch = False
        Dim Last_Fetched
        Last_Fetched = TimeDiff(str_TempImg)
        If (Last_Fetched > ExpiryTimeInMins Or Last_Fetched < 0) Then
        ' Old file --> Get a new one
            Fetch = True
        End If

        If Fetch Then
            Dim OK
            OK = ReturnBinary(URL, str_TempImg)
        End If

        If OK And Fetch Then
        ' Image downloaded was succesfully
            Fetch_Image = str_TempImg
        Else
            If Not OK And Fetch Then
            ' Image download was UNsuccesfull --> find out why
                Fetch_Image = SamurizePath & "Error.png"
            Else
            ' Image was up to date --> No need to download
                Fetch_Image = str_TempImg
            End If
        End If
    Else
        Fetch_Image = SamurizePath & "Error.png"
    End If
    Set fso = Nothing
    
    If Link_to_File Then
        Fetch_Image = Fetch_Image & "%lexplorer.exe " & Fetch_Image
    End If
End Function

Private Function ReadXML()
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set f = fso.GetFile(SamurizePath & "Fetch Image.xml")
    ReadXML = f.OpenAsTextStream(1, -2).readall
    Set fso = Nothing
    Set f = Nothing
End Function

Private Function ReturnHTML(URL)
    Dim objXMLHTTP, HTML
    Set objXMLHTTP = CreateObject("MSXML2.ServerXMLHTTP")
    On Error Resume Next
    objXMLHTTP.Open "GET", URL, False
    objXMLHTTP.Send
    If Err = 0 And objXMLHTTP.Status = 200 Then
        HTML = objXMLHTTP.responseBody
        Set objRS = CreateObject("ADODB.Recordset")
        objRS.Fields.Append "txt", 200, 35000, &H80
        objRS.Open
        objRS.AddNew
        objRS.Fields("txt").AppendChunk HTML
        ReturnHTML = objRS("txt").Value
        objRS.Close
        Set objRS = Nothing
    Else
        ReturnHTML = False
    End If
    On Error GoTo 0
    Set objXMLHTTP = Nothing
End Function

Private Function ReturnBinary(sURL, IMGTemp)
    Set HTTP = CreateObject("Microsoft.XMLHTTP")
    HTTP.Open "GET", sURL, False
    HTTP.Send
    If Err = 0 And HTTP.Status = 200 Then
        Set Stream = CreateObject("adodb.stream")
        Const adTypeBinary = 1
        Const adSaveCreateNotExist = 1
        Const adSaveCreateOverWrite = 2
        Stream.Type = adTypeBinary
        Stream.Open
        Stream.write HTTP.responseBody
        Stream.SaveToFile IMGTemp, adSaveCreateOverWrite
        Set Stream = Nothing
        ReturnBinary = True
    Else
        ReturnBinary = False
    End If
    Set HTTP = Nothing
End Function

Private Function TimeDiff(FileName)
    Dim fso, f
    Dim diff
    Set fso = CreateObject("Scripting.FileSystemObject")
    If fso.FileExists(FileName) Then
        Set f = fso.GetFile(FileName)
        TimeDiff = DateDiff("n", f.DateLastModified, Now)
    Else
        TimeDiff = -1
    End If
    Set f = Nothing
    Set fso = Nothing
End Function

Private Function SamurizePath()
'Path to Samurize folder
    SamurizePath = CreateObject("WScript.Shell").RegRead("HKEY_CURRENT_USER\Software\Serious Samurize\General\DirPath")
End Function

